PSMTPServer Class Reference

A TCP/IP socket for the Simple Mail Transfer Protocol. More...

`#include <inetmail.h>`

Inheritance diagram for PSMTPServer:

## Public Types

enum | ForwardResult { LocalDomain, WillForward, CannotForward }
enum | LookUpResult { ValidUser, AmbiguousUser, UnknownUser, LookUpError }
Public Types inherited from PSMTP
enum | Commands { HELO, EHLO, QUIT, HELP, NOOP, TURN, RSET, VRFY, EXPN, RCPT, MAIL, SEND, SAML, SOML, DATA, AUTH, NumCommands }
Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef std::vector< Slice > | VectorOfSlice
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Public Member Functions

| PSMTPServer ()
| Create a TCP/IP SMPTP protocol socket channel. More...
PBoolean | ProcessCommand ()
| Process commands, dispatching to the appropriate virtual function. More...
void | ServerReset ()
virtual ForwardResult | ForwardDomain (PCaselessString &userDomain, PCaselessString &forwardDomainList)
| Determine if a user for this domain may be on the local system, or should be forwarded. More...
virtual LookUpResult | LookUpName (const PCaselessString &name, PString &expandedName)
| Look up a name in the context of the SMTP server. More...
virtual PBoolean | HandleMessage (PCharArray &buffer, PBoolean starting, PBoolean completed)
| Handle a received message. More...
Public Member Functions inherited from PInternetProtocol
virtual PBoolean | Read (void *buf, PINDEX len)
| Low level read from the channel. More...
virtual PBoolean | Write (const void *buf, PINDEX len)
| Low level write to the channel. More...
void | SetReadLineTimeout (const PTimeInterval &t)
| Set the maximum timeout between characters within a line. More...
virtual PBoolean | Connect (const PString &address, WORD port=0)
| Connect a socket to a remote host for the internet protocol. More...
virtual PBoolean | Connect (const PString &address, const PString &service)
virtual PBoolean | Accept (PSocket &listener)
| Accept a server socket to a remote host for the internet protocol. More...
const PString & | GetDefaultService () const
| Get the default service name or port number to use in socket connections. More...
PIPSocket * | GetSocket () const
| Get the eventual socket for the series of indirect channels that may be between the current protocol and the actual I/O channel. More...
virtual PBoolean | WriteLine (const PString &line)
| Write a string to the socket channel followed by a CR/LF pair. More...
virtual PBoolean | ReadLine (PString &line, PBoolean allowContinuation=false)
| Read a string from the socket channel up to a CR/LF pair. More...
virtual void | UnRead (int ch)
| Put back the characters into the data stream so that the next Read() function call will return them first. More...
virtual void | UnRead (const PString &str)
virtual void | UnRead (const void *buffer, PINDEX len)
virtual PBoolean | WriteCommand (PINDEX cmdNumber)
| Write a single line for a command. More...
virtual PBoolean | WriteCommand (PINDEX cmdNumber, const PString &param)
virtual PBoolean | ReadCommand (PINDEX &num, PString &args)
| Read a single line of a command which ends with a CR/LF pair. More...
virtual PBoolean | WriteResponse (unsigned numericCode, const PString &info)
| Write a response code followed by a text string describing the response to a command. More...
virtual PBoolean | WriteResponse (const PString &code, const PString &info)
virtual PBoolean | ReadResponse ()
| Read a response code followed by a text string describing the response to a command. More...
virtual PBoolean | ReadResponse (int &code, PString &info)
virtual int | ExecuteCommand (PINDEX cmdNumber)
| Write a command to the socket, using `WriteCommand()` and await a response using `ReadResponse()`. More...
virtual int | ExecuteCommand (PINDEX cmdNumber, const PString &param)
int | GetLastResponseCode () const
| Return the code associated with the last response received by the socket. More...
PString | GetLastResponseInfo () const
| Return the last response received by the socket. More...
Public Member Functions inherited from PIndirectChannel
| PIndirectChannel ()
| Create a new indirect channel without any channels to redirect to. More...
| ~PIndirectChannel ()
| Close the indirect channel, deleting read/write channels if desired. More...
Comparison | Compare (const PObject &obj) const
| Determine if the two objects refer to the same indirect channel. More...
virtual PString | GetName () const
| Get the name of the channel. More...
virtual PBoolean | Close ()
| Close the channel. More...
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open and read and write operations can be executed on it. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual PChannel * | GetBaseReadChannel () const
| This function returns the eventual base channel for reading of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PChannel * | GetBaseWriteChannel () const
| This function returns the eventual base channel for writing of a series of indirect channels provided by descendents of `PIndirectChannel`. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
PBoolean | Open (PChannel &channel)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *channel, PBoolean autoDelete=true)
| Set the channel for both read and write operations. More...
PBoolean | Open (PChannel *readChannel, PChannel *writeChannel, PBoolean autoDeleteRead=true, PBoolean autoDeleteWrite=true)
| Set the channel for both read and write operations. More...
PChannel * | GetReadChannel () const
| Get the channel used for read operations. More...
bool | SetReadChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
PChannel * | GetWriteChannel () const
| Get the channel used for write operations. More...
PBoolean | SetWriteChannel (PChannel *channel, bool autoDelete=true, bool closeExisting=false)
| Set the channel for read operations. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
| PChannel ()
| Create the channel. More...
| ~PChannel ()
| Close down the channel. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
int | GetHandle () const
| Get the integer operating system handle for the channel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
virtual PBoolean | ReadAsync (void *buf, PINDEX len)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (void *buf, PINDEX len)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *mark)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
virtual PBoolean | WriteAsync (const void *buf, PINDEX len)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (const void *buf, PINDEX len)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PBoolean | Read (const VectorOfSlice &slices)
| Low level scattered read from the channel. More...
virtual PBoolean | Write (const VectorOfSlice &slices)
| Low level scattered write to the channel. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Types

enum | { WasMAIL, WasSEND, WasSAML, WasSOML }
Protected Types inherited from PInternetProtocol
enum | StuffState { DontStuff, StuffIdle, StuffCR, StuffCRLF, StuffCRLFdot, StuffCRLFdotCR }

## Protected Member Functions

PBoolean | OnOpen ()
| This callback is executed when the Open() function is called with open channels. More...
virtual void | OnHELO (const PCaselessString &remoteHost)
virtual void | OnEHLO (const PCaselessString &remoteHost)
virtual void | OnQUIT ()
virtual void | OnHELP ()
virtual void | OnNOOP ()
virtual void | OnTURN ()
virtual void | OnRSET ()
virtual void | OnVRFY (const PCaselessString &name)
virtual void | OnEXPN (const PCaselessString &name)
virtual void | OnRCPT (const PCaselessString &recipient)
virtual void | OnMAIL (const PCaselessString &sender)
virtual void | OnSEND (const PCaselessString &sender)
virtual void | OnSAML (const PCaselessString &sender)
virtual void | OnSOML (const PCaselessString &sender)
virtual void | OnDATA ()
virtual PBoolean | OnUnknown (const PCaselessString &command)
| Handle an unknown command. More...
virtual void | OnSendMail (const PCaselessString &sender)
virtual PBoolean | OnTextData (PCharArray &buffer, PBoolean &completed)
| Read a standard text message that is being received by the socket. More...
virtual PBoolean | OnMIMEData (PCharArray &buffer, PBoolean &completed)
| Read an eight bit MIME message that is being received by the socket. More...
Protected Member Functions inherited from PSMTP
| PSMTP ()
Protected Member Functions inherited from PInternetProtocol
| PInternetProtocol (const char *defaultServiceName, PINDEX cmdCount, char const *const *cmdNames)
virtual PINDEX | ParseResponse (const PString &line)
| Parse a response line string into a response code and any extra info on the line. More...
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (int libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
int | PXClose ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes

PBoolean | extendedHello
PBoolean | eightBitMIME
PString | fromAddress
PString | fromPath
PStringList | toNames
PStringList | toDomains
PINDEX | messageBufferSize
enum PSMTPServer:: { ... } | sendCommand
StuffState | endMIMEDetectState
Protected Attributes inherited from PInternetProtocol
PString | defaultServiceName
PStringArray | commandNames
PCharArray | unReadBuffer
PINDEX | unReadCount
PTimeInterval | readLineTimeout
enum PInternetProtocol::StuffState | stuffingState
PBoolean | newLineToCRLF
int | lastResponseCode
PString | lastResponseInfo
Protected Attributes inherited from PIndirectChannel
PChannel * | readChannel
| Channel for read operations. More...
PBoolean | readAutoDelete
| Automatically delete read channel on destruction. More...
PChannel * | writeChannel
| Channel for write operations. More...
PBoolean | writeAutoDelete
| Automatically delete write channel on destruction. More...
PReadWriteMutex | channelPointerMutex
| Race condition prevention on closing channel. More...
Protected Attributes inherited from PChannel
int | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]

## Additional Inherited Members

Static Public Member Functions inherited from PChannel
static PBoolean | ConvertOSError (int libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Detailed Description

A TCP/IP socket for the Simple Mail Transfer Protocol.

When acting as a client, the procedure is to make the connection to a remote server, then to send a message using the following procedure: `PSMTPSocket mail("mailserver"); if (mail.IsOpen()) { mail.BeginMessage("Me@here.com.au", "Fred@somwhere.com"); mail.Write(myMessage); if (!mail.EndMessage()) PError << "Mail send failed." << endl; } else PError << "Mail conection failed." << endl;`

When acting as a server, a descendant class would be created to override at least the LookUpName() and HandleMessage() functions. Other functions may be overridden for further enhancement to the sockets capabilities, but these two will give a basic SMTP server functionality.

The server socket thread would continuously call the ProcessMessage() function until it returns false. This will then call the appropriate virtual function on parsing the SMTP protocol.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

protected

Enumerator
WasMAIL |
WasSEND |
WasSAML |
WasSOML |

## ForwardResult

enum PSMTPServer::ForwardResult

Enumerator
LocalDomain | User may be on local machine, do LookUpName().
WillForward | User may be forwarded to another SMTP host.
CannotForward | User cannot be forwarded.

## LookUpResult

enum PSMTPServer::LookUpResult

Enumerator
ValidUser | User name was valid and unique.
AmbiguousUser | User name was valid but ambiguous.
UnknownUser | User name was invalid.
LookUpError | Some other error occurred in look up.

## Constructor & Destructor Documentation

## PSMTPServer()

PSMTPServer::PSMTPServer | ( |  | ) |

Create a TCP/IP SMPTP protocol socket channel.

The parameterless form creates an unopened socket, the form with the `address` parameter makes a connection to a remote system, opening the socket. The form with the `socket` parameter opens the socket to an incoming call from a "listening" socket.

## Member Function Documentation

## ForwardDomain()

virtual ForwardResult PSMTPServer::ForwardDomain | ( | PCaselessString & | userDomain,
|  | PCaselessString & | forwardDomainList
| ) |  |

virtual

Determine if a user for this domain may be on the local system, or should be forwarded.

Returns
  Result of forward check operation.

Parameters

  userDomain | Domain for user
  forwardDomainList | Domains forwarding to

## HandleMessage()

virtual PBoolean PSMTPServer::HandleMessage | ( | PCharArray & | buffer,
|  | PBoolean | starting,
|  | PBoolean | completed
| ) |  |

virtual

Handle a received message.

The `buffer` parameter contains the partial or complete message received, depending on the `completed` parameter.

The default behaviour is to simply return false;

Returns
  true if message was handled, false if an error occurs.

Parameters

  buffer | Buffer containing message data received.
  starting | This is the first call for the message.
  completed | This is the last call for the message. Indication that the entire message has been received.

## LookUpName()

virtual LookUpResult PSMTPServer::LookUpName | ( | const PCaselessString & | name,
|  | PString & | expandedName
| ) |  |

virtual

Look up a name in the context of the SMTP server.

The default bahaviour simply returns false.

Returns
  Result of name look up operation.

Parameters

  name | Name to look up.
  expandedName | Expanded form of name (if found).

## OnDATA()

virtual void PSMTPServer::OnDATA | ( |  | ) |

protected virtual

## OnEHLO()

virtual void PSMTPServer::OnEHLO | ( | const PCaselessString & | remoteHost | ) |

protected virtual

Parameters

  remoteHost | Name of remote host.

## OnEXPN()

virtual void PSMTPServer::OnEXPN | ( | const PCaselessString & | name | ) |

protected virtual

Parameters

  name | Name to expand.

## OnHELO()

virtual void PSMTPServer::OnHELO | ( | const PCaselessString & | remoteHost | ) |

protected virtual

Parameters

  remoteHost | Name of remote host.

## OnHELP()

virtual void PSMTPServer::OnHELP | ( |  | ) |

protected virtual

## OnMAIL()

virtual void PSMTPServer::OnMAIL | ( | const PCaselessString & | sender | ) |

protected virtual

Parameters

  sender | Name of sender.

## OnMIMEData()

virtual PBoolean PSMTPServer::OnMIMEData | ( | PCharArray & | buffer,
|  | PBoolean & | completed
| ) |  |

protected virtual

Read an eight bit MIME message that is being received by the socket.

The MIME message is terminated by the CR/LF/./CR/LF sequence.

The default behaviour is to read the data into the `buffer` parameter until either the end of the message or when the `messageBufferSize` bytes have been read.

Returns
  true if partial message received, false if the end of the data was received.

## OnNOOP()

virtual void PSMTPServer::OnNOOP | ( |  | ) |

protected virtual

## OnOpen()

PBoolean PSMTPServer::OnOpen | ( |  | ) |

protected virtual

This callback is executed when the Open() function is called with open channels.

It may be used by descendent channels to do any handshaking required by the protocol that channel embodies.

The default behaviour is to simply return true.

Returns
  Returns true if the protocol handshaking is successful.

Reimplemented from PIndirectChannel.

## OnQUIT()

virtual void PSMTPServer::OnQUIT | ( |  | ) |

protected virtual

## OnRCPT()

virtual void PSMTPServer::OnRCPT | ( | const PCaselessString & | recipient | ) |

protected virtual

Parameters

  recipient | Name of recipient.

## OnRSET()

virtual void PSMTPServer::OnRSET | ( |  | ) |

protected virtual

## OnSAML()

virtual void PSMTPServer::OnSAML | ( | const PCaselessString & | sender | ) |

protected virtual

Parameters

  sender | Name of sender.

## OnSEND()

virtual void PSMTPServer::OnSEND | ( | const PCaselessString & | sender | ) |

protected virtual

Parameters

  sender | Name of sender.

## OnSendMail()

virtual void PSMTPServer::OnSendMail | ( | const PCaselessString & | sender | ) |

protected virtual

Parameters

  sender | Name of sender.

## OnSOML()

virtual void PSMTPServer::OnSOML | ( | const PCaselessString & | sender | ) |

protected virtual

Parameters

  sender | Name of sender.

## OnTextData()

virtual PBoolean PSMTPServer::OnTextData | ( | PCharArray & | buffer,
|  | PBoolean & | completed
| ) |  |

protected virtual

Read a standard text message that is being received by the socket.

The text message is terminated by a line with a '.' character alone.

The default behaviour is to read the data into the `buffer` parameter until either the end of the message or when the `messageBufferSize` bytes have been read.

Returns
  true if partial message received, false if the end of the data was received.

## OnTURN()

virtual void PSMTPServer::OnTURN | ( |  | ) |

protected virtual

## OnUnknown()

virtual PBoolean PSMTPServer::OnUnknown | ( | const PCaselessString & | command | ) |

protected virtual

Handle an unknown command.

Returns
  true if more processing may be done, false if the ProcessCommand() function is to return false.

Parameters

  command | Complete command line received.

## OnVRFY()

virtual void PSMTPServer::OnVRFY | ( | const PCaselessString & | name | ) |

protected virtual

Parameters

  name | Name to verify.

## ProcessCommand()

PBoolean PSMTPServer::ProcessCommand | ( |  | ) |

Process commands, dispatching to the appropriate virtual function.

This is used when the socket is acting as a server.

Returns
  true if more processing may be done, false if the QUIT command was received or the OnUnknown() function returns false.

## ServerReset()

void PSMTPServer::ServerReset | ( |  | ) |

## Member Data Documentation

## eightBitMIME

PBoolean PSMTPServer::eightBitMIME

protected

## endMIMEDetectState

StuffState PSMTPServer::endMIMEDetectState

protected

## extendedHello

PBoolean PSMTPServer::extendedHello

protected

## fromAddress

PString PSMTPServer::fromAddress

protected

## fromPath

PString PSMTPServer::fromPath

protected

## messageBufferSize

PINDEX PSMTPServer::messageBufferSize

protected

## sendCommand

enum { ... } PSMTPServer::sendCommand

## toDomains

PStringList PSMTPServer::toDomains

protected

## toNames

PStringList PSMTPServer::toNames

protected

The documentation for this class was generated from the following file:

- inetmail.h